<?php
namespace Teknisa\MAN\Controllers;
    
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Notification; 
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;

class AudTaxController extends CrudWithParameterBag {
    const AUDTAX = 'vnd55500_VendasAudTax';
    
    protected $dataSourceName = AudTaxController::AUDTAX;
    protected $parameterBagColumns = array('CDFILIAL', 'NRORG', 'IDSENDAUDTAX');

    protected $crudService;
    protected $parameterBag;
    protected $dataSourceManager;
    protected $AudTaxControllerService;
    
    public function __construct($crudService, $parameterBag, Manager $dataSourceManager, Services\AudTaxControllerService $AudTaxControllerService) {
        $this->crudService       = $crudService;
        $this->parameterBag      = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->AudTaxControllerService = $AudTaxControllerService;
    }
    
    public function findGetAdquirentes ($NRORG) {
        $KeyToken = $this->AudTaxControllerService->getKeyToken($NRORG);
        $headers =  array(
            "App-Key:".$KeyToken['CDKEYAUDTAX'],
            "AudtaxCardToken:".$KeyToken['CDTOKENAUDTAX']
        );
        // Get cURL resource
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_URL, 'https://developers.audtaxcard.com.br/api/v1.0/adquirentes/getadquirentes');
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_PROXY, '192.168.122.150');
        curl_setopt($curl, CURLOPT_PROXYPORT, '3128');
        // Send the request & save response to $resp
        $resp = curl_exec($curl);
        // Close request to clear up some resources

        curl_close($curl);
        var_dump($resp);die();
    }

    public function findGetProdutos ($NRORG) {
        $KeyToken = $this->AudTaxControllerService->getKeyToken($NRORG);
        $headers =  array(
            "App-Key:".$KeyToken['CDKEYAUDTAX'],
            "AudtaxCardToken:".$KeyToken['CDTOKENAUDTAX']
        );
        // Get cURL resource
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_URL, 'https://developers.audtaxcard.com.br/api/v1.0/produtos/getprodutos');
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_PROXY, '192.168.122.150');
        curl_setopt($curl, CURLOPT_PROXYPORT, '3128');
        // Send the request & save response to $resp
        $resp = curl_exec($curl);
        // Close request to clear up some resources

        curl_close($curl);
        return json_decode($resp);
    }

    public function findGetMeiosCaptura ($NRORG) {
        $this->dataSourceName = 'vnd55500_VendasAudTax';

        $KeyToken = $this->AudTaxControllerService->getKeyToken($NRORG);
        $headers =  array(
            "App-Key:".$KeyToken['CDKEYAUDTAX'],
            "AudtaxCardToken:".$KeyToken['CDTOKENAUDTAX']
        );
        // Get cURL resource
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_URL, 'https://developers.audtaxcard.com.br/api/v1.0/meioscaptura/getmeioscaptura');
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_PROXY, '192.168.122.150');
        curl_setopt($curl, CURLOPT_PROXYPORT, '3128');
        // Send the request & save response to $resp
        $resp = curl_exec($curl);
        // Close request to clear up some resources

        curl_close($curl);
        var_dump($resp);die();
    }

    public function findGetEstabelecimentos ($NRORG) {
        $KeyToken = $this->AudTaxControllerService->getKeyToken($NRORG);
        $headers =  array(
            "App-Key:".$KeyToken['CDKEYAUDTAX'],
            "AudtaxCardToken:".$KeyToken['CDTOKENAUDTAX']
        );
        // Get cURL resource
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_URL, 'https://developers.audtaxcard.com.br/api/v1.0/estabelecimentos/getestabelecimentos');
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_PROXY, '192.168.122.150');
        curl_setopt($curl, CURLOPT_PROXYPORT, '3128');
        // Send the request & save response to $resp
        $resp = curl_exec($curl);
        // Close request to clear up some resources

        curl_close($curl);
        $return = json_decode($resp);
        if (isset($return->auth_code)){
            return json_decode("{\"data\":\"-1\",\"auth_message\":\"Authentication Required\"}");
        }else{
            return $return;
        }
    }

    public function findGetMarketPlaces ($NRORG) {
        $this->dataSourceName = 'vnd55500_VendasAudTax';
        
        $KeyToken = $this->AudTaxControllerService->getKeyToken($NRORG);
        $headers =  array(
            "App-Key:".$KeyToken['CDKEYAUDTAX'],
            "AudtaxCardToken:".$KeyToken['CDTOKENAUDTAX']
        );
        // Get cURL resource
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_URL, 'https://developers.audtaxcard.com.br/api/v1.0/marketplaces/getmarketplaces');
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_PROXY, '192.168.122.150');
        curl_setopt($curl, CURLOPT_PROXYPORT, '3128');
        // Send the request & save response to $resp
        $resp = curl_exec($curl);
        // Close request to clear up some resources

        curl_close($curl);
        var_dump($resp);die();
    }

    public function findGetVendasPerDate ($NRORG) {
        $this->dataSourceName = 'vnd55500_VendasAudTax';

        $KeyToken = $this->AudTaxControllerService->getKeyToken($NRORG);
        $headers =  array(
            "App-Key:".$KeyToken['CDKEYAUDTAX'],
            "AudtaxCardToken:".$KeyToken['CDTOKENAUDTAX']
        );
        // Get cURL resource
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_URL, 'https://developers.audtaxcard.com.br/api/v1.0/erpvendas/geterpvendas/2015-06-01/2015-06-02/1');
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_PROXY, '192.168.122.150');
        curl_setopt($curl, CURLOPT_PROXYPORT, '3128');
        // Send the request & save response to $resp
        $resp = curl_exec($curl);
        // Close request to clear up some resources

        curl_close($curl);
        var_dump($resp);die();
    }

    public function getSalesToAudTax (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = AudTaxController::AUDTAX;
        parent::find($request, $response);
    }

    public function sendSalesToAudtax (DTO\Request\DataSet $request, DTO\Response $response){
        $this->dataSourceName = AudTaxController::AUDTAX;
        $request->getDataSet()->setDataSourceName(AudTaxController::AUDTAX);
        $row = $request->getDataSet()->getRows();
        $salesToSend = [];
        $unidadesToEstabelecimentos = [];
        $arrayResponse = [];
        foreach ($row as $venda) {
            if (!isset($id_estabelecimento)){
                $KeyToken = $this->AudTaxControllerService->getKeyToken($venda['NRORG']);
                $estabelecimentos = $this->findGetEstabelecimentos($venda['NRORG'])->data;
                if ($estabelecimentos <> -1){
                    $Produtos = $this->findGetProdutos($venda['NRORG'])->data;
                    $id_estabelecimento = $this->handleEstabelecimen($estabelecimentos, $venda['NRINSJURFILI'], count($estabelecimentos)-1);
                    $DTENTRVENDAINI = $venda['DATAEDITADA'];
                    $DTENTRVENDAFIN = $venda['DATAEDITADA'];
                    $CDFILIAL = $venda['CDFILIAL'];
                    $NRORG = $venda['NRORG'];
                    $IDSENDAUDTAX = 'S';
                }else{
                    $response->setError(new DTO\Response\Error('Key e Token não cadastrado', '1'));
                    break;
                }
            }
            $codigo_produto = $this->handleProduct($venda['CDTIPORECE'], $venda['NMTIPORECE'], $venda['IDTIPORECE']);
            $params = array(
                'nsu' => $venda['CDNSUHOSTTEF'],
                'valor' => $venda['VRMOVIVEND'],
                'parcelas' => $venda['QTPARCRECEB'],
                'autorizacao' => $venda['CDNSUHOSTTEF'],
                'id_erp' => $venda['CDFILIAL'].$venda['CDLOJA'].$venda['CDCAIXA'].str_replace('/', '', $venda['DATAEDITADA']).$venda['NRSEQVENDA'].$venda['NRSEQUMOVI'],
                'numero_cartao' => $venda['NRCARTBANCO'],
                'data_venda' => $venda['DATATOSEND'],
                'codigo_meio_captura' => '02',
                'id_adquirente' => '10',
                'tid' => '',
                'codigo_produto' => $codigo_produto,
                'status' => 'n',
                'id_estabelecimento' => $id_estabelecimento
            );
            array_push($salesToSend, $params);
            array_push($unidadesToEstabelecimentos, $venda['CDFILIAL']);
            $this->AudTaxControllerService->setSendAudTax($venda['CDFILIAL'], $venda['CDCAIXA'], $venda['NRSEQVENDA'], $venda['NRSEQUMOVI'], $venda['NRORG'], 'S');
        }
        $salesToSend = array_chunk($salesToSend, 50);
        $headers =  array(
            "App-Key:".$KeyToken['CDKEYAUDTAX'],
            "AudtaxCardToken:".$KeyToken['CDTOKENAUDTAX'],
            "Content-Type:application/json"
        );
        foreach ($salesToSend as $package) {
            // Get cURL resource
            $curl = curl_init();

            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($curl, CURLOPT_URL, 'https://developers.audtaxcard.com.br/api/v1.0/erpvendas/posterpvendas');
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_PROXY, $KeyToken['PROXYAUDTAX']);
            curl_setopt($curl, CURLOPT_PROXYPORT, $KeyToken['PORTAUDTAX']);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($package));
            
            // Send the request & save response to $resp
            $resp = curl_exec($curl);
            
            // Close request to clear up some resources
            curl_close($curl);
            array_push($arrayResponse, $resp);
        }
        
        if (isset($resp)) {
            $data = json_decode($resp)->message;
            $response->addNotification(new Notification($data, Notification::TYPE_SUCCESS));
        } else{  
            $response->setError(new DTO\Response\Error('Key e Token Incorretos!', '1'));
        }
    }

    public function handleEstabelecimen($estabelecimento, $jurfili, $key){
        for ($key=$key; $key > 0; $key--) { 
            if (str_replace('-', '', str_replace('/', '', str_replace('.', '', $estabelecimento[$key]->cnpj))) == $jurfili){
                return $estabelecimento[$key]->codigo_estabelecimento;
            }
        }
    }

    public function handleProduct($tipoRece, $nmtipoRece, $tipoCard){
        if ($tipoCard == '1') { 
            switch (strtolower($nmtipoRece)) {
                case strstr(strtolower($nmtipoRece), 'master'):
                    return '010';
                    break;
                case strstr(strtolower($nmtipoRece), 'visa'):
                    return '040';
                    break;
                case strstr(strtolower($nmtipoRece), 'sodex'):
                    return 'RM3';
                    break;
                case strstr(strtolower($nmtipoRece), 'american'):
                    return  'AMV';
                    break;
                case strstr(strtolower($nmtipoRece), 'ticket'):
                    return  'RM1';
                    break;
                default:
                    return '000';
                    break;
            }
        }
        elseif ($tipoCard == '2') {
            switch (strtolower($nmtipoRece)) {
                case strstr(strtolower($nmtipoRece), 'master'):
                    return 'MASTD';
                    break;
                case strstr(strtolower($nmtipoRece), 'visa'):
                    return 'VISAD';
                    break;
                case strstr(strtolower($nmtipoRece), 'sodex'):
                    return 'RM3';
                    break;
                case strstr(strtolower($nmtipoRece), 'ticket'):
                    return  'RM1';
                    break;
                default:
                    return '000';
                    break;
            }
        }
    }
}

//"App-Key:KNcpu86985bnd782puGL",                     ( Não utilizar essa informação para o Mal )
//"AudtaxCardToken:12AC0C14382868794FB4179EB0ED54D8"  ( Não utilizar essa informação para o Mal )