<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelMTCOperador {
    
    protected $relMTC;
    protected $util;

    public function __construct (Utilities\Util $util,  Services\RelMTCOperadorService $relMTC){
        $this->utilService = $util;
        $this->reportService = $relMTC;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        
        ini_set('max_execution_time', 1800);
		ini_set('memory_limit', '1G');
        
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
      
        $return = $this->reportService->getBase($conditions);
        
        $allData = [];
        $Positions = [];
        
        foreach ($return as $dados){
            $prod = array_column($dados, null, 'INDEXPRODUTO');
            $diff = array_diff_key($prod, $allData);
            $diffOutside = true;
            $intersectOutside = true;
            $intersect = array_intersect_key($prod, $allData);
            if (!empty($diff)){
                foreach ($diff as $chave => $value) {
                    $allData[$chave] = $value;
                }
                $diffOutside = false;
            }
            
            if(!empty($intersect)){
                foreach ($intersect as $chave => $value) {
                        $keys = array_keys($value);
                        $labelIndexVR  = array_pop($keys);
                        $labelIndexQTD = array_pop($keys);
                        $labelIndexMTC = array_pop($keys);
                        $allData[$chave][$labelIndexVR]  = $value[$labelIndexVR];
                        $allData[$chave][$labelIndexQTD] = $value[$labelIndexQTD];
                        $allData[$chave][$labelIndexMTC] = $value[$labelIndexMTC];
                }
                $intersectOutside = false;
            }
        }
        
        $allData = array_values( $allData);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('orm00018_relMTCOperador', $allData));
    }
    
    
}