<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelTabelaDePreco extends CrudWithParameterBag {
    
    protected $relTabelaDePrecoService;
    protected $util;
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Services\RelTabelaDePrecoService $relTabelaDePrecoService, Utilities\Util $util){
        $this->tabelaDePrecoService = $relTabelaDePrecoService;
        parent::__construct($dataSourceManager, $parameterBag);
        $this->util = $util;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
       $conditions = $this->util->getParamsAsArray($request);
       if (empty($conditions['CDPRODFIN'])){
            $conditions['CDPRODFIN'] = $conditions['CDPRODINI'];
       } 
       $INTERVALO = explode('-',$conditions['INTERVALVIGENCIA']);
       $retorno = $this->tabelaDePrecoService->find($conditions['CDTABEPREC'], $conditions['CDFILIAL'], $INTERVALO[0], $INTERVALO[1], $conditions['CDPRODINI'], $conditions['CDPRODFIN'], $conditions['CDNVPRODUTO']);
       $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('vnd42401_relTabelaDePreco', $retorno));
    }
    
    public function findVigencias (DTO\Request\Filter $request, DTO\Response $response){
        $conditions = $this->util->getParamsAsArray($request);
        $retorno = $this->tabelaDePrecoService->getVigenciaInterval($conditions['NRORG'], $conditions['CDTABPREC'], $conditions['CDFILIAL']);
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('findVigencias', $retorno));
    }
}
